package net.lecnam.info.channel;

import java.io.IOException;
import java.util.concurrent.BlockingQueue;

public class LocalObjectReader<A> implements ObjectReader<A> {

	BlockingQueue<A> bq;
	
	public LocalObjectReader(BlockingQueue<A> bq) {
		this.bq = bq;
	}

	@Override
	public A readObject() throws IOException {
		try {
			return bq.take();
		} catch (InterruptedException e) {
			throw new IOException(e);
		}
	}

}
