package net.lecnam.info.channel;

import java.io.IOException;
import java.util.concurrent.BlockingQueue;

public class LocalObjectWriter<B> implements ObjectWriter<B> {

	BlockingQueue<B> bq;
	
	public LocalObjectWriter(BlockingQueue<B> bq) {
		this.bq = bq;
	}

	@Override
	public void writeObject(B arg) throws IOException {
		try {
			bq.put(arg);
		} catch (InterruptedException e) {
			throw new IOException(e);
		}
	}

}
