package net.lecnam.info.ex3;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

import net.lecnam.info.channel.ObjectReader;
import net.lecnam.info.channel.ObjectWriter;

public class ComputeEngine<T> implements Runnable {

	ObjectReader<Task<T>> in;
	ObjectWriter<T> out;

	Logger logger = Logger.getLogger("Server");

	ComputeEngine(ObjectReader<Task<T>> in, ObjectWriter<T> out) {
		this.in = in;
		this.out = out;
	}

	public T executeTask(Task<T> task) throws IOException {
		return task.execute();
	}

	@Override
	public void run() {
		try {
			boolean done = false;
			while (!done) {
				Task<T> task = in.readObject();
				T result = executeTask(task);
				if (result == null) {
					done = true;
				} else {
					out.writeObject(result);
				}
			}
		} catch (IOException ex) {
			throw new Error(ex);
		}
	}

}
